# Warehouse Management (WM)

## What To Expect For Other Groups
#### API Contracts
- **No APIs made for public consumption.**

#### Inventory, Pricing, & Promotions
- Warehouse Management (WM) to provide Kafka message upon order fulfillment or cancellation.

#### E-Commerce
- None

#### Order Management
- Warehouse Management (WM) to expect Kafka message upon order creation.
- WM to provide Kafka message upon order fulfillment or cancellation.

---

## Details
### Schemas
#### Warehouse Order
```
{
    id: String,
    orderId: String,
    status: String "RECEIVED" (default) > "FULFILLED"/"CANCELLED",
    createdAt: Date,
    modifiedAt: Date,
    orderItems: List<Item>,
    address: String,
}
```

#### Item
```
{
    itemId: String,
    itemName: String,
    itemQuantity: int,
    itemPrice: float,
    itemSku: int,
}
```

### Workflow
- Warehouse Management (WM) expects an Order object from Order Management (OM) on order creation in Kafka.
- On receipt of an Order object, WM will create a warehouse order entry in database with a status of **"RECEIVED"**.
- In the WM UI, a warehouse manager will have the ability to fulfill or cancel unfulfilled orders.
- When an order is marked **"FULFILLED"** or **"CANCELLED"**, a Kafka message will be sent to be consumed.

### UI
- Login/Logout
- Order Status and Update orders as **"FULFILLED"** or **"CANCELLED"**
- Order Filter and Search
- Order Details

#### API Documentation
https://documenter.getpostman.com/view/7402212/TzRNGATe
